unit Eq2maped1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, TFlatMemoUnit, TFlatListBoxUnit, TFlatEditUnit,
  dxCore, dxButtons, JvSimpleXml, Buttons, ComCtrls, RzTreeVw, Menus,
  ActnList, TFlatSpinEditUnit, TFlatComboBoxUnit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    xmlscan: TJvSimpleXML;
    OpenDlg: TOpenDialog;
    Panel2: TPanel;
    jvTreeView1: TRzTreeView;
    Label1: TLabel;
    Label3: TLabel;
    FlatEdit3: TFlatEdit;
    Label2: TLabel;
    FlatMemo1: TFlatMemo;
    dxButton3: TdxButton;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    FileOpen: TAction;
    FileSave: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    FileExit: TAction;
    N4: TMenuItem;
    posbtn: TShape;
    FlatEdit4: TFlatEdit;
    FileMAP: TAction;
    openmap: TOpenDialog;
    ed_locX: TFlatSpinEditInteger;
    ed_locY: TFlatSpinEditInteger;
    N5: TMenuItem;
    M1: TMenuItem;
    MAPADD: TAction;
    A1: TMenuItem;
    N6: TMenuItem;
    cb_icontype: TFlatComboBox;
    FlatEdit1: TFlatEdit;
    MAPPOI: TAction;
    POIO1: TMenuItem;
    procedure xmlscanDecodeValue(Sender: TObject; var Value: String);
    procedure xmlscanEncodeValue(Sender: TObject; var Value: String);
    procedure FormCreate(Sender: TObject);
    procedure FlatMemo1Change(Sender: TObject);
    procedure dxButton3Click(Sender: TObject);
    procedure jvTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FileOpenExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FlatEdit3Change(Sender: TObject);
    procedure FileExitExecute(Sender: TObject);
    procedure FlatEdit4Change(Sender: TObject);
    procedure FileMAPExecute(Sender: TObject);
    procedure MAPADDExecute(Sender: TObject);
    procedure MAPPOIUpdate(Sender: TObject);
    procedure MAPPOIExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ismodified : boolean;
    isLoaded : boolean;
    function LoadDDS(FileName : string):TBitmap;
    function LoadXML(FileName : string):String;
    function ReFreshView:string;
    procedure LoadINI;
  end;

var
  Form1: TForm1;
  exepath : string;
  ddsgamma : extended = 0.8;

const
        pathmap = 'images\maps\';
        pathdmp = '..\Defaults\'+pathmap;
        pathico = 'eq2map\';
        PgName = 'Eq2MAP Editor';
        tagUTF8BOM : array[0..2] of byte = ($EF, $BB, $BF);
        specialname : array[1..5] of string = ('&amp;','&lt;','&gt;','&quot;','&apos;');
        specialchar : array[1..5] of char = ('&','<','>','"',#39);

implementation

{$R *.DFM}

uses imaging, imagingtypes, cUnicodeCodecs, inifiles, poipost1;

var     gatable : array[0..255] of byte;


// for gamma correction
procedure makegammatable( value : extended );
var
        i : byte;
        j : integer;
        exv : extended;
begin
        if value = 1 then begin
                for i:=0 to 255 do gatable[i]:=i;
        end else begin
                gatable[0]:=0;
                for i:=1 to 255 do begin
                        exv := 255 * exp(value * ln(i/255)) + 0.5;
                        j := round(exv);
                        if j>255 then j:=255;
                        gatable[i]:= byte(255 and j);
                end;
        end;
end;

procedure GCorrection(sbmp : Tbitmap; ga : extended);
var
        i, j : integer;
        sl : pbytearray;
begin
        makegammatable(ga);
        for j:=0 to sbmp.Height-1 do begin
        sl := sbmp.ScanLine[j];
        for i:=0 to (sbmp.Width-1)*4 do sl^[i] := gatable[sl^[i]];
        end;
end;

// ===
function decodeXML(const val : string):String;
var
        i : integer;
begin
        Result := val;
        for i:=1 to 5 do
        Result := StringReplace(Result,specialname[i],specialchar[i],[rfReplaceAll, rfIgnoreCase]);
end;

function encodeXML(const val : string):string;
var
        i : integer;
begin
        Result := val;
        for i:=1 to 5 do
        Result := StringReplace(Result,specialchar[i],specialname[i],[rfReplaceAll]);
end;

function TForm1.LoadDDS(FileName : string):TBitmap;
var
        Img : TImageData;
        i : integer;
begin
        Result := nil;
        InitImage(Img);
        try
        if imaging.LoadImageFromFile(Filename,Img) then begin
                Result := TBitmap.Create;
                try
                Result.HandleType := bmDIB;
                Result.PixelFormat := pf32bit;
                Result.Width  := Img.Width;
                Result.Height := Img.Height;
                ConvertImage(Img,ifA8R8G8B8);
                for i:=0 to pred(Img.Height) do begin
                        Move(PColor32RecArray(Img.Bits)[I * Img.Width],Result.ScanLine[i]^,Img.Width * GetPixelBytes(Img.Format));
                end;
                GCorrection(result,ddsgamma);
                except
                        Result.Free;
                        Result := nil;
                end;
        end else begin
                result := TBitmap.Create;
                try
                Result.HandleType := bmDIB;
                Result.PixelFormat := pf32bit;
                Result.Width := 512;
                Result.Height:= 512;
                Result.Canvas.FillRect(RECT(0,0,511,511));
                except
                        Result.Free;
                        Result := nil;
                end;
        end;
        finally
                FreeImage(Img);
        end;
end;

function TForm1.ReFreshView:string;
var
        i : integer;
        tmp : TTreenode;
begin
        jvTreeView1.Items.BeginUpdate;
        jvTreeView1.Items.Clear;
        FlatEdit4.OnChange := nil;
        FlatEdit4.Text := xmlscan.Root.Properties.ItemNamed['1location'].Value;
        FlatEdit4.Modified := false;
        FlatEdit4.OnChange := FlatEdit4Change;
        Result  := xmlscan.Root.Properties.ItemNamed['Name'].Value;
        try
        for i:=0 to pred(xmlscan.Root.Items.Count) do begin
                with xmlscan.Root.Items.Item[i].Properties do begin
                tmp := jvTreeView1.Items.Add(nil,ItemNamed['Name'].Value);
                if tmp<>nil then begin
                tmp.Data := pointer(i);
                jvTreeView1.Items.AddChild(tmp,ItemNamed['Location'].Value);
                jvTreeView1.Items.AddChild(tmp,ItemNamed['pathfindlocation'].Value);
                jvTreeView1.Items.AddChild(tmp,ItemNamed['IconStyle'].Value);
                jvTreeView1.Items.AddChild(tmp,ItemNamed['Tooltip'].Value);
                end;
                end;
        end;
        except
        end;
        jvTreeView1.Items.EndUpdate;
end;

function TForm1.LoadXML(FileName : string):String;
var
        sFile : TFileStream;
        buff : array[0..3] of byte;
        isSafe : boolean;
        itm : TJvSimpleXMLProp;
begin
        // load
        Result := '';
        isSafe := false;
        fillchar(buff,3,0);
        jvTreeView1.Items.BeginUpdate;
        jvTreeView1.Items.Clear;
        jvTreeView1.Items.EndUpdate;
        xmlScan.Prolog.Clear;
        xmlScan.Root.Clear;
        try
        sFile := TFileStream.Create(FileName,fmOpenRead or fmShareDenyWrite);
        try
                        // check header
                if 3<>sFile.Read(buff,3) then raise exception.Create('Error : Bad File');
                if (buff[0]<>$EF) or (buff[1]<>$BB) or (buff[2]<>$BF) then sFile.Position := 0;
                XmlScan.LoadFromStream(sFile);
                // patch items = bug fix
                itm := xmlscan.Root.Properties.ItemNamed['1Location'];
                if itm<>nil then itm.Name := '1location';
                // View Map
                Result := ReFreshView;
                isSafe := true;
        finally
                sFile.Free;
                if not isSafe then raise exception.Create('Error : Loading File');
        end;
        except
        on e:exception do ShowMessage(e.message);
        end;
end;

procedure TForm1.xmlscanDecodeValue(Sender: TObject; var Value: String);
var
        sx : Widestring;
begin
        sx := UTF8StringToWideString(Value);
        Value := DecodeXML(sx);
end;

procedure TForm1.xmlscanEncodeValue(Sender: TObject; var Value: String);
var
        sx : String;
begin
        sx := WideStringToUTF8String(Value);
        Value := EncodeXML(sx);
end;

procedure TForm1.LoadINI;
var
        xf : TIniFile;
        sr : string;
begin
        sr := ChangeFileExt(Application.EXEName,'.INI');
        try
        if FileExists(sr) then begin
        xf := TINIFile.Create(sr);
        try
                ddsgamma := xf.ReadFloat('CONFIG','MAPGAMMA',0.8);
        finally
                xf.free;
        end;
        end;
        except
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
        ix : integer;
begin
        isLoaded := false;
        Exepath := ExtractFilePath(Application.ExeName);
        ix := GetSystemDefaultLangID;
        if lo(ix)<>LANG_KOREAN then begin
                Form1.Font.Name := 'MS Sans Serif';
                Form1.Font.Size := 8;
                FileOpen.Caption := '&Open';
                FileSave.Caption := '&Save';
                FileExit.Caption := 'E&xit';
                FileMap.Caption := 'Load &Map';
                dxbutton3.Caption:= 'Apply';
                N1.Caption := '&File';
                N5.Caption := 'Ma&p';
                MAPADD.Caption := '&Add map point';
                MAPPOI.Caption := 'Post to P&OI';
                Label1.Caption := 'Loc ';
                Label2.Caption := 'Name';
                Label3.Caption := 'Type';
                Label4.Caption := 'Path';
        end;
        openMap.InitialDir := EXEPath+pathmap;
        loadINI;
end;

function GetTagptr(itm :tjvSimpleXMLProps; Name : string; sr : TStringList):boolean;
var
        idx : TjvSimpleXMLProp;
begin
        Result := false;
        idx := itm.ItemNamed[Name];
        if idx<>nil then begin
                sr.Add(idx.Name);
                sr.Add(idx.Value);
                result := true;
        end;
end;

procedure SortItems(itm : tjvSimpleXMLProps);
var
        i, j : integer;
        tmp : tStringList;
begin
        tmp := TStringList.Create;
        try
                GetTagptr(itm,'IconStyle',tmp);
                GetTagptr(itm,'IconType',tmp);
                GetTagptr(itm,'Location',tmp);
                GetTagptr(itm,'Name',tmp);
                GetTagptr(itm,'OnHoverIn',tmp);
                GetTagptr(itm,'pathfindlocation',tmp);
                GetTagptr(itm,'ScrollExtent',tmp);
                GetTagptr(itm,'Size',tmp);
                GetTagptr(itm,'Tooltip',tmp);
                GetTagptr(itm,'TreatAsButton',tmp);
                itm.Clear;
                j := tmp.Count shr 1;
                for i:=0 to pred(j) do itm.Add(tmp.Strings[i*2],tmp.Strings[i*2+1]);
        finally
                tmp.free;
        end;
end;

procedure TForm1.FlatMemo1Change(Sender: TObject);
begin
        if isLoaded then dxbutton3.Enabled := true;
end;

procedure TForm1.dxButton3Click(Sender: TObject);
var
        ix : integer;
        sel : TTreeNode;
begin
        if not isLoaded then exit;
        // ===
        sel := jvTreeView1.Selected;
        if sel=nil then exit;
        if sel.Parent<>nil then sel := sel.Parent;
        ix := integer(sel.data);

        if ix <> -1 then begin
        with xmlscan.Root.Items.Item[ix].Properties do begin
        try
        ItemNamed['Tooltip'].Value := FlatMemo1.Text;
        ItemNamed['Name'].Value := FlatEdit3.Text;
        ItemNamed['IconStyle'].Value := cb_icontype.Text;
        ItemNamed['Location'].Value := ed_locX.Text +','+ed_locY.Text;
        ItemNamed['pathfindlocation'].Value := FlatEdit1.Text;
        Sel.DeleteChildren;
        Sel.Text := FlatEdit3.Text;
        jvTreeView1.Items.AddChild(sel,ItemNamed['Location'].Value);
        jvTreeView1.Items.AddChild(sel,ItemNamed['pathfindlocation'].Value);
        jvTreeView1.Items.AddChild(sel,ItemNamed['IconStyle'].Value);
        jvTreeView1.Items.AddChild(sel,ItemNamed['Tooltip'].Value);
        isModified := true;
        FlatMemo1.Modified := false;
        FlatEdit3.Modified := false;
        FileSave.Enabled := true;
        dxbutton3.Enabled := false;
        except
        end;
        end; // with
        end;
end;

procedure TForm1.jvTreeView1Change(Sender: TObject; Node: TTreeNode);
var
        ix, x, y, sw, sh : integer;
        st, sx : string;
        sel : TTreeNode;
begin
        sel := jvTreeView1.Selected;
        if sel=nil then exit;
        if sel.Parent<>nil then exit;
        ix := integer(sel.data);
        if ix <> -1 then begin
                try
                st := xmlscan.Root.Items.Item[ix].Properties.ItemNamed['Location'].Value;
                x := strtoint(copy(st,0,pos(',',st)-1));
                y := strtoint(copy(st,pos(',',st)+1,5));
                ed_locX.Value := x;
                ed_locY.Value := y;
                cb_icontype.Text := xmlscan.Root.Items.Item[ix].Properties.ItemNamed['IconStyle'].Value;
                FlatEdit3.Text := xmlscan.root.items.item[ix].Properties.ItemNamed['Name'].Value;
                FlatEdit1.Text := xmlscan.Root.Items.Item[ix].Properties.ItemNamed['pathfindlocation'].Value;
                FlatMemo1.Text := xmlscan.root.items.item[ix].Properties.ItemNamed['Tooltip'].Value;
                sx := xmlscan.root.items.item[ix].Properties.ItemNamed['Size'].Value;
                sw := strtoint(copy(sx,0,pos(',',sx)-1));
                sh := strtoint(copy(sx,pos(',',sx)+1,2));
                posbtn.Width := sw;
                posbtn.Height:= sh;
                posbtn.Left := x - sw shr 1;
                posbtn.Top := y - sh shr 1;
                posbtn.Hint := FlatMemo1.Text;
                if Uppercase(cb_icontype.Text) = 'ZONE' then posbtn.Shape := stCircle
                        else  posbtn.Shape := stRoundRect;
                except
                end;
                FlatMemo1.Modified := false;
                FlatEdit3.Modified := false;
                ed_locX.Modified := false;
                ed_locY.Modified := false;
                dxbutton3.Enabled := false;
        end;
end;

procedure TForm1.FileOpenExecute(Sender: TObject);
var
        fn, fr : string;
        tb : TBitmap;
begin
        opendlg.InitialDir := EXEPath+pathico;
        if openDlg.Execute then begin
                isLoaded := false;
                self.caption := PgName + ' ['+ EXtractFileName(opendlg.FileName)+']';
                fn := LoadXML(opendlg.FileName);
                fr := EXEPath + pathmap + 'map_'+fn+'.dds';
                tb := nil;
                if FileExists(fr) then tb := LoadDDS(fr);
                if tb=nil then begin
                        tb := TBitmap.Create;
                        try
                        tb.HandleType := bmDIB;
                        tb.PixelFormat := pf32bit;
                        tb.Width := 512;
                        tb.Height:= 512;
                        except
                                tb.free;
                                tb := nil;
                        end;
                end;
                Image1.Picture.Bitmap.Assign(tb);
                if tb<>nil then tb.free;
                ed_locX.Value := 0;
                ed_locY.Value := 0;
                cb_icontype.ItemIndex := -1;
                FlatEdit3.Text := '';
                FlatEdit1.Text := '';
                FlatMemo1.Text := '';
                MapAdd.Enabled := true;
                isLoaded := true;
        end;
end;

procedure TForm1.FileSaveExecute(Sender: TObject);
var
        sname : string;
        sFile : TFileStream;
        mFile : TMemoryStream;
        isSafe : boolean;
        firstCR : boolean;
        rbyte : byte;
        pData : PByteArray;
        i : integer;
        itm : TjvSimpleXMLProps;
begin
        if not isLoaded then begin
                ShowMessage('No File Loaded');
                exit;
        end;
        sname := XmlScan.Root.Properties.ItemNamed['Name'].Value;
        // Refine Tags
        for i:=0 to pred(XmlScan.Root.Items.Count) do begin
                if XmlScan.Root.Items.Item[i].Name = 'Icon' then begin
                        itm := XmlScan.Root.Items.Item[i].Properties;
                        SortItems(itm);
                end;
        end;
        // save to stream first
        isSafe := false; firstCR := false;

        mFile := TMemoryStream.Create;
        try
                XMLScan.SaveToStream(mFile);
                mFile.Position := 0;
                sFile := TFileStream.Create(EXEPath+PathIco+'icons_'+sname+'.xml',fmCreate);
                try
                        if 3<>sFile.Write(tagUTF8BOM,3) then raise exception.Create('Error');
                        while not firstCR do begin
                                if 1<>mFile.Read(rbyte,1) then break;
                                if rbyte=$0d then begin
                                        if 1<>mFile.Read(rbyte,1) then raise exception.Create('Error');
                                        rbyte := $0a;
                                        if 1<>sFile.Write(rbyte,1) then raise exception.Create('Error');
                                        firstCR := true;
                                end else begin
                                        if 1<>sFile.Write(rbyte,1) then raise exception.Create('Error');
                                end;
                        end;
                        pData := mFile.Memory;
                        sFile.Write(pData^[mFile.Position],mFile.Size - mFile.Position);
                        isSafe := true;
                finally
                        sFile.Free;
                        if not isSafe then raise exception.Create('Error');
                end;
        //
        isModified := false;
        FileSave.Enabled := false;
        finally
                mFile.Free;
                if not isSafe then Showmessage('Error in saving file');
        end;
end;

procedure TForm1.FlatEdit3Change(Sender: TObject);
begin
        if isLoaded then dxButton3.Enabled := true;
end;

procedure TForm1.FileExitExecute(Sender: TObject);
begin
        close;
end;

procedure TForm1.FlatEdit4Change(Sender: TObject);
begin
        if isLoaded then
        if Flatedit4.Modified then begin
                xmlscan.Root.Properties.ItemNamed['1location'].Value := FlatEdit4.Text;
                FlatEdit4.Modified := false;
                isModified := true;
                FileSave.Enabled := true;
        end;

end;

procedure TForm1.FileMAPExecute(Sender: TObject);
var
        TB : TBitmap;
begin
        if OpenMap.Execute then begin
                tb := nil;
                try
                if FileExists(OpenMap.FileName) then tb := LoadDDS(OpenMap.FileName);
                if tb=nil then begin
                        tb := TBitmap.Create;
                        try
                        tb.HandleType := bmDIB;
                        tb.PixelFormat := pf32bit;
                        tb.Width := 512;
                        tb.Height:= 512;
                        except
                                tb.free;
                                tb := nil;
                        end;
                end;
                Image1.Picture.Bitmap.Assign(tb);
                if tb<>nil then tb.free;
                except
                        ShowMessage('Map Loading Fail.');
                end;
        end;
end;

procedure TForm1.MAPADDExecute(Sender: TObject);
var
        tmp : TjvsimpleXMLElemClassic;
begin
        if isLoaded then begin
                try
                tmp := xmlscan.Root.Items.add('Icon');
                tmp.Properties.Add('IconStyle','MOB');
                tmp.Properties.Add('IconType','map');
                tmp.Properties.Add('Location','0,0');
                tmp.Properties.Add('Name','AnyWhere');
                tmp.Properties.Add('OnHoverIn','Parent.Parent.Parent.Parent.WC_Titlebar.QM_LocEntry.QM_LocText.LocalText=pathfindlocation');
                tmp.Properties.Add('pathfindlocation','0, 0, 0');
                tmp.Properties.Add('ScrollExtent','12,12');
                tmp.Properties.Add('Size','12,12');
                tmp.Properties.Add('Tooltip','New Point');
                tmp.Properties.Add('TreatAsButton','true');
                ReFreshView;
                FileSave.Enabled := true;
                isModified := true;
                except
                        Showmessage('Cannot add point');
                end;
        end;
end;

procedure TForm1.MAPPOIUpdate(Sender: TObject);
var
        sel : TTreenode;
begin
        sel := jvTreeView1.Selected;
        if sel = nil then MAPPOI.Enabled := false else begin
                if isLoaded and (sel.Parent=nil) then MAPPOI.Enabled := true else MAPPOI.Enabled := false;
        end;
end;

procedure TForm1.MAPPOIExecute(Sender: TObject);
var
        sform : TForm2;
        sel : TTreenode;
        ix : integer;
begin
        sel := jvTreeView1.Selected;
        if sel=nil then exit;
        if sel.Parent<>nil then exit;
        ix := integer(sel.data);
        try
                sform := TForm2.Create(self);
        try
                sform.ed_name.Text := xmlscan.Root.Items[ix].Properties.ItemNamed['Name'].Value;
                sform.SetType(xmlscan.Root.Items[ix].Properties.ItemNamed['IconStyle'].Value);
                sform.ed_zone.Text := xmlscan.Root.Properties.ItemNamed['1location'].Value;
                sform.ed_pathloc.Text := xmlscan.Root.Items[ix].Properties.ItemNamed['pathfindlocation'].Value;
                sform.ed_desc.Text := xmlscan.Root.Items[ix].Properties.ItemNamed['Tooltip'].Value;
                sform.ShowModal;
        finally
                sform.Free;
        end;
        except
                Showmessage('Summit Fail.');
        end;
end;

end.
