{ Imaging options }

{$DEFINE RAISE_EXCEPTIONS} // if defined, errors in Imaging will raise
                           // EImaginError exceptions on some errors
{$DEFINE USE_INLINE}       // use function inlining for some functions
                           // works in Free Pascal and Delphi 9+
{$DEFINE USE_ASM}          // if defined, assembler versions of some
                           // functions will be used
{ $DEFINE DEBUG}            // if defined, debug info and range/IO/overflow
                           // checking will be turned on


{ Compiler options }

{$ALIGN on}                // Fields alignment: 8 B
{$ASSERTIONS ON}          // Assertions: on
{$BOOLEVAL OFF}           // Boolean eval: off
{$EXTENDEDSYNTAX ON}      // Extended syntax: on
{$LONGSTRINGS ON}         // string = AnsiString: on
{$MINENUMSIZE 4}          // Min enum size: 4 B
{$TYPEDADDRESS OFF}       // Typed pointers: off
{$WRITEABLECONST OFF}     // Writeable constants: off

{$IFDEF DEBUG}
  {$DEBUGINFO ON}
  {$LOCALSYMBOLS ON}
  {$RANGECHECKS ON}
  {$IOCHECKS ON}
  {$OVERFLOWCHECKS ON}
{$ELSE}
  {$DEBUGINFO OFF}
  {$LOCALSYMBOLS OFF}
  {$RANGECHECKS OFF}
  {$IOCHECKS OFF}
  {$OVERFLOWCHECKS OFF}
{$ENDIF}

{ Imaging options check}

{$IFDEF USE_INLINE}
  {$IFNDEF VER170}
    //{$IFNDEF FPC}  //  FPC inline support is now disable because it is buggy
      {$UNDEF USE_INLINE}
    //{$ENDIF}
  {$ENDIF}
{$ENDIF}


{ Platform options }

{$IFDEF WIN32}
  {$DEFINE MSWINDOWS}
{$ENDIF}

{$IFDEF DPMI}
  {$DEFINE MSDOS}
{$ENDIF}

{$IFDEF UNIX}
  {$DEFINE LINUX}
{$ENDIF}


{ More compiler options }

{$IFDEF FPC}               // Free pascal options
  {$ASMMODE INTEL}         // intel assembler mode
  {$MODE DELPHI}           // compatible with delphi
  {$GOTO ON}               // alow goto
  {$PACKRECORDS 8}         // same as ALING 8 for Delphi
  {$INLINE ON}             // turn on/off function inlining
  {$CALLING REGISTER}      // default calling convention is register
  {$IFNDEF DYN_LIBRARY}
    {$SMARTLINK ON}        // smartlinking on, but not for dll/so -
                           // nothing gets exported from library when it is on
                           // in FPC 1.9.8
  {$ENDIF}
{$ENDIF}

{$IFDEF VER170}            // Delphi 9 options
  {$INLINE ON}             // turns inlining on for Delphi 9
{$ENDIF}


{ Linking options }

{ $DEFINE LINK_JPEG}        // link support for Jpeg images
{ $DEFINE LINK_PNG}         // link support for Png images
{ $DEFINE LINK_TARGA}       // link support for Targa images
{ $DEFINE LINK_BITMAP}      // link support for Windows Bitmap images
{$DEFINE LINK_DDS}         // link support for DDS images

//{$DEFINE LINK_DRAWING}     // link drawing function
//{$DEFINE LINK_EFFECTS}     // link effect functions

